# R-EDL: Relaxing nonessential settings of evidential deep learning

**Authors**: Anonymous Authors

### Dependencies:
Here we list our used requirements and dependencies.
 - GPU: GeForce RTX 3090
 - Python: 3.8.5
 - PyTorch: 1.12.0
 - Numpy: 1.21.2
 - Pandas: 1.1.3
 - Scipy: 1.3.1
 - Scikit-learn: 1.0.1
 - Wandb: 0.12.6
 - Tqdm: 4.62.3

### Data preparation:
The required datasets (MNIST/FMNIST/KMNIST/CIFAR-10/CIFAR-100/SVHN) will be automatically downloaded if your server has an Internet connection.

### Pre-trained models:
The pre-trained models can be downloaded from [Google Disk](https://drive.google.com/file/d/1e1qZBAJQlsHBbl3tjfIuouMqHd9UpbkK/view?usp=sharing).

They need to be unzipped and put in the directory './code_classical/saved_models/'.

### Test pre-trained models:
Just run:
   ```
   python main.py --configid "1_mnist/mnist-redl-test" --suffix test
   ```
Or:
   ```
   python main.py --configid "2_cifar10/cifar10-redl-test" --suffix test
   ```

### Train from scratch:
   
Just run:
   ```
   python main.py --configid "1_mnist/mnist-redl-train" --suffix test
   ```
Or:
   ```
   python main.py --configid "2_cifar10/cifar10-redl-train" --suffix test
   ```

